-- SPACE ROCKS 2 -PSP- by Greg Tourville aka XiGency
-- [[
--	port of my Space Rocks PC game
--
--	todo: add high score
--		add bg music that works
-- ]]

------------------------------------------------------------
-- INITIALIZATION

math.randomseed(os.time())
maxStars = 150
maxAliens = 3
maxRocks =3
maxLasers=40
maxExplosions = 10
laserCharge=10
shootWait=0
exframes=9
rocksLeft=5
score=0
level=0
health=10
lbActive=0


width = 480
height = 272
bgmusic = Sound.load("space.wav", true)
local sound = bgmusic
sound:play()
expsnd = Sound.load("deepexp.wav")
lasersnd = Sound.load("photon2.wav")
elasersnd = Sound.load("elshot.wav")
shipimg = Image.load("ship.png")
alienimg = Image.load("alien.png")
rockimg = Image.load("rock.png")
expimg = Image.load("explode.png")
exprockimg = Image.load("explode2.png")
laserimg = Image.load("bullet.png")
elaserimg = Image.load("ebullet.png")
shipX=width/2
shipY=height-40

lasers = {}
explosions = {}
stars = {}
aliens = {}
rocks = {}
starc = {}
fadegreen = {}
fadered = {}
fadeblue = {}
fadewhite = {}
fadewhitered = {}

for i=1, 5 do
	starc[i] = {}
	starc[i].clr= Color.new(295-(i*40),295-(i*40),295-(i*40))
end


white = Color.new(255,255,255)
black = Color.new(0,0,0)
blue = Color.new(0,0,255)
green = Color.new(0,255,0)
red = Color.new(255,0,0)

for i=1, 255 do
	fadegreen[i] = {}
	fadegreen[i].clr= Color.new(0,i,0)
end

for i=1, 255 do
	fadeblue[i] = {}
	fadeblue[i].clr= Color.new(0,0,i)
end


for i=1, 255 do
	fadered[i] = {}
	fadered[i].clr= Color.new(i,0,0)
end

for i=1, 255 do
	fadewhitered[i] = {}
	fadewhitered[i].clr= Color.new(255,i,i)
end

for i=1, 255 do
	fadewhite[i] = {}
	fadewhite[i].clr= Color.new(i,i,i)
end

---------------------------------------------
-- FUNCTIONS

function delay(seconds)
	time=seconds*60
	for i=1, time do
		screen.waitVblankStart()
	end
end 

function createStar(i)
	stars[i] = {}
	stars[i].xp=math.random(width)
	stars[i].yp=math.random(height)-height
	z = math.random(4)
	stars[i].ysp = (5-z)
	stars[i].b = z
end

function createAlien(i)
	aliens[i] = {}
	aliens[i].xp=math.random(width-alienimg:width())
	aliens[i].yp=math.random(height)-height-alienimg:height()
	aliens[i].xsp=math.random(11)-5.5
	aliens[i].ysp=math.random(3)+3
	aliens[i].swait=0
end

function createRock(i)
	rocks[i] = {}
	rocks[i].xp=math.random(width-rockimg:width())
	rocks[i].yp=math.random(height)-height-rockimg:height()
	rocks[i].xsp=math.random(5)-2.5
	rocks[i].ysp=math.random(5)+2
end

function createExplosion(x,y,type)
	v=expsnd:play()
	ex=0
	for i=1, maxExplosions do
		if ex==1 then break end
		if explosions[i].active==0 then
			explosions[i] = {}
			explosions[i].xp=x
			explosions[i].yp=y
			explosions[i].type=type
			explosions[i].active=1
			explosions[i].frame=0
			ex=1
		end
	end
end

function createLaser(x,y,type)
	if type==1 then v=lasersnd:play() end
	if type==2 then v=elasersnd:play() end
	ex=0
	for i=1,maxLasers do
		if ex==1 then break end
		if lasers[i].active==0 then
			lasers[i] = {}
			lasers[i].xp=x
			lasers[i].yp=y
			lasers[i].type=type
			lasers[i].active=1
			ex=1
		end
	end
end



for i=1, maxStars do
	createStar(i)
	stars[i].yp = stars[i].yp + height
end



function updateStars()
	for i=1, maxStars do
		speed = stars[i].ysp
		stars[i].yp = stars[i].yp + speed
		sx = stars[i].xp
		sy = stars[i].yp
		b = stars[i].b
		clr = starc[b].clr

		if sy<height and sy>0 and sx<width and sx>0 then 
			screen:pixel(sx, sy, clr)
		else
			createStar(i) 
		end

	end
end

function updateAliens()
	for i=1, maxAliens do
		aliens[i].xp=aliens[i].xp+aliens[i].xsp
		aliens[i].yp=aliens[i].yp+aliens[i].ysp
		x=aliens[i].xp
		y=aliens[i].yp
		if aliens[i].swait>0 then aliens[i].swait=aliens[i].swait-1 end
		if x<0 or x>width-alienimg:width() then aliens[i].xsp=-aliens[i].xsp end

		if y<height then 
			if math.random(30)==3 and aliens[i].swait==0 and y>0-alienimg:width() then 
				createLaser(x+(alienimg:width()/2),y+alienimg:height(),2) 
				aliens[i].swait=8
			end
			
			if y>0-alienimg:height() then screen:blit(x,y,alienimg) end
		else
			createAlien(i) 
		end


		if lbActive==1 then
			if lbX>x and lbX<x+alienimg:width() then
				createExplosion(x,y,1)
				createAlien(i)
				score=score+1000
			end
		end

	end
end 


function updateRocks()
	for i=1, maxRocks do
		rocks[i].xp=rocks[i].xp+rocks[i].xsp
		rocks[i].yp=rocks[i].yp+rocks[i].ysp
		x=rocks[i].xp
		y=rocks[i].yp

		if y<height then 
			if y>0-rockimg:height() then screen:blit(x,y,rockimg) end
		else
			createRock(i) 
		end

		if shipX+shipimg:width()>rocks[i].xp and shipY+shipimg:height()>rocks[i].yp and shipX<rocks[i].xp+rockimg:width() and shipY<rocks[i].yp+rockimg:width() then
			createExplosion(rocks[i].xp,rocks[i].yp,2)
			createRock(i)
			health=health-1
			rocksLeft=rocksLeft-1
		end

		if lbActive==1 then
			if lbX>rocks[i].xp and lbX<rocks[i].xp+rockimg:width() then
				createExplosion(rocks[i].xp,rocks[i].yp,2)
				createRock(i)
				score=score+200
				rocksLeft=rocksLeft-1
			end
		end

	end
end 


function drawHud()
	z=laserCharge*10
	w=health*10
	screen:fillRect(10,10,100,10, red)
	screen:fillRect(10,10,w,10, blue)
	screen:print(35,11,"HEALTH", white)
	screen:fillRect(10,30,100,10, red)
	screen:fillRect(10,30,z,10, green)
	screen:print(35,31,"LASER", white)
	screen:print(10,50,"Score: ", green)
	screen:print(10,65,"Rocks Left:", green)
	screen:print(60,50,score, green)
	screen:print(100,65,rocksLeft, green)

end


function updateExplosions()
	for i=1, maxExplosions do
		if explosions[i].active==1 then
			x=explosions[i].xp
			y=explosions[i].yp
			wid=(expimg:width()/exframes)
			heig=expimg:height()
			xs=wid*explosions[i].frame
			ys=0

			if explosions[i].type==1 then screen:blit(x,y,expimg,xs,ys,wid,heig) end
			if explosions[i].type==2 then screen:blit(x,y,exprockimg,xs,ys,wid,heig) end
			explosions[i].frame=explosions[i].frame+1
			if explosions[i].frame >= (exframes-1) then explosions[i].active=0 end
		end
	end
end

function updateLasers()
	for i=1, maxLasers do
		ex=0
		if lasers[i].active == 1 then
			x=lasers[i].xp
			y=lasers[i].yp

			if lasers[i].type==1 then
				lasers[i].yp=lasers[i].yp-8
				screen:blit(x,y,laserimg)


				for q=1, maxRocks do
					if x>rocks[q].xp and y>rocks[q].yp and x<rocks[q].xp+rockimg:width() and y<rocks[q].yp+rockimg:width() then
						createExplosion(rocks[q].xp,rocks[q].yp,2)
						createRock(q)
						score=score+100
						lasers[i].active=0
						rocksLeft=rocksLeft-1
					end
				end

				for q=1, maxAliens do
					if x>aliens[q].xp and y>aliens[q].yp and x<aliens[q].xp+alienimg:width() and y<aliens[q].yp+alienimg:width() then
						createExplosion(aliens[q].xp,aliens[q].yp,1)
						createAlien(q)
						score=score+500
						lasers[i].active=0
					end
				end

			else
				lasers[i].yp=lasers[i].yp+8
				screen:blit(x,y,elaserimg)

				if x>shipX and y>shipY and x<shipX+shipimg:width() and y<shipY+shipimg:height() then
					createExplosion(shipX,shipY,1)
					health=health-1
					lasers[i].active=0
				end
			end	

			if lasers[i].yp<0 or lasers[i].yp>height then lasers[i].active=0 end
		end
	end
end

function initLevel()
	level=level+1
	maxRocks=level
	maxAliens=level-1
	rocksLeft=level*3+2

	for i=1, maxAliens do
		createAlien(i)
	end

	for i=1, maxRocks do
		createRock(i)
	end

	for i=1, maxExplosions do
		explosions[i] = {}
		explosions[i].active=0
	end

	for i=1, maxLasers do
		lasers[i] = {}
		lasers[i].active=0
	end

	screen:clear(black)
	screen:print(199,140,"SECTOR",green)
	screen:print(251,140,level,green)
	screen.flip()
	delay(2)
end

function pause()
	delay(0.5)
	while true do
		screen:clear(black)
		screen:print(200,140,"PAUSED",fadered[254].clr)
		screen:print(185,170,"PRESS START",fadered[254].clr)
		updateStars()
		drawHud()
		screen.waitVblankStart()
		screen.flip()
		screen.waitVblankStart()
		if Controls.read():start() then break end
	end
	delay(0.5)
end


---------------------------------------
-- cool INTRO

khit=0

for i=1, 255,2 do
	if Controls.read():start() then khit=1 end
	if khit==1 then break end
	screen:clear(black)
	screen:print(150,140,"gb games presents...",fadegreen[i].clr)
	screen.waitVblankStart()
	screen.flip()
end
for i=255,1,-2 do
	if Controls.read():start() then khit=1 end
	if khit==1 then break end
	screen:clear(black)
	screen:print(150,140,"gb games presents...",fadegreen[i].clr)
	screen.waitVblankStart()
	screen.flip()
end

for i=1, 255,2 do
	if Controls.read():start() then khit=1 end
	if khit==1 then break end
	screen:clear(black)
	screen:print(155,140,"a game for psp...",fadegreen[i].clr)
	screen.waitVblankStart()
	screen.flip()
end
for i=255,1,-2 do
	if Controls.read():start() then khit=1 end
	if khit==1 then break end
	screen:clear(black)
	screen:print(155,140,"a game for psp...",fadegreen[i].clr)
	screen.waitVblankStart()
	screen.flip()
end

for i=1, 255,2 do
	if Controls.read():start() then khit=1 end
	if khit==1 then break end
	screen:clear(black)
	screen:print(155,140,"...by greg tourville",fadered[i].clr)
	screen.waitVblankStart()
	screen.flip()
end
for i=255,1,-2 do
	if Controls.read():start() then khit=1 end
	if khit==1 then break end
	screen:clear(fadewhite[256-i].clr)
	screen:print(155,140,"...by greg tourville",fadewhitered[256-i].clr)
	screen.waitVblankStart()
	screen.flip()
end

for i=255,1,-2 do
	if Controls.read():start() then khit=1 end
	if khit==1 then break end
	screen:clear(fadewhite[i].clr)
	screen.waitVblankStart()
	screen.flip()
end



----------------------------------------
-- MENU
delay(0.25)

flash=1
d=1
backc=2

while true do
	screen:clear(fadered[backc].clr)
	screen.waitVblankStart()
	updateStars()
	screen:print(180,125,"SPACE ROCKS 2",blue)
	screen:print(168,145,"By Greg Tourville",fadegreen[255-(backc*2)].clr)
	if flash > 30 then screen:print(182,165,"(press start)",blue) end
	flash=flash+1
	if flash>60 then flash=1 end
	if Controls.read():start() then break end
	backc=backc+d
	if backc>80 or backc<2 then d=-d end
	screen.waitVblankStart()
	screen.flip()
end


initLevel()


-----------------------------------------------------------
-- MAIN LOOP

while true do

	pad = Controls.read()
	ax=0
	ay=0
	ax = pad:analogX()
	ay = pad:analogY()
	if pad:up() then ay=-127 end
	if pad:down() then ay=127 end
	if pad:left() then ax=-127 end
	if pad:right() then ax=127 end


	if shootWait > 0 then shootWait=shootWait-1 end



	if (pad:r() or pad:cross() or pad:circle()) and shootWait==0 and laserCharge>=1 then 
		createLaser(shipX,shipY+10,1) 
		createLaser(shipX+40,shipY+10,1)
		shootWait=7
		laserCharge=laserCharge-1
	end

	if (pad:l() or pad:triangle() or pad:square()) and lbActive==0 and laserCharge>=7 then
		laserCharge=laserCharge-7
		lbActive=1
		lbX=shipX+shipimg:width()/2
		lbY=shipY
		lbL=30
		lbC=254
	end

	if laserCharge<10 then laserCharge=laserCharge+0.05 end


	if ax>32 or ax<-32 then shipX = shipX + ax/20 end
	if ay>32 or ay<-32 then shipY = shipY + ay/20 end


	if shipX>width-shipimg:width() then shipX=width-shipimg:width() end
	if shipX<0 then shipX=0 end
	if shipY>height-shipimg:height() then shipY=height-shipimg:height() end
	if shipY<0 then shipY=0 end


	screen:clear(black)

	updateLasers()
	updateStars()
	updateRocks()

	screen:blit(shipX, shipY, shipimg)


	updateAliens()
	updateExplosions()


	if lbActive==1 then
		if lbC>60 then screen:drawLine(lbX-2,height-lbL,lbX-2,height,fadewhite[lbC-60].clr) end
		if lbC>30 then screen:drawLine(lbX-1,height-lbL,lbX-1,height,fadewhite[lbC-30].clr) end
		screen:drawLine(lbX-2,height-lbL,lbX,height,fadewhite[lbC].clr)
		if lbC>30 then screen:drawLine(lbX+1,height-lbL,lbX+1,height,fadewhite[lbC-30].clr) end
		if lbC>60 then screen:drawLine(lbX+2,height-lbL,lbX+2,height,fadewhite[lbC-60].clr) end

		if (height-lbL)>0 then lbL=lbL+30 end
		lbC=lbC-4
		if lbC<5 then lbActive=0 end
	end


	drawHud()

	if pad:select() or health<1 then break end

	if pad:start() then pause() end


	screen.waitVblankStart()
	screen.flip()

	if rocksLeft<1 then initLevel() end

end

-------------------------------------
-- GAME OVER

screen:clear(black)
screen:print(200,140,"GAME OVER",green)
screen.flip()
delay(3)
